
_mask:

;7SegDis.c,3 :: 		unsigned short mask(unsigned short num) {
;7SegDis.c,4 :: 		switch (num) {
	GOTO       L_mask0
;7SegDis.c,5 :: 		case 0 : return 0x3F;
L_mask2:
	MOVLW      63
	MOVWF      R0+0
	GOTO       L_end_mask
;7SegDis.c,6 :: 		case 1 : return 0x06;
L_mask3:
	MOVLW      6
	MOVWF      R0+0
	GOTO       L_end_mask
;7SegDis.c,7 :: 		case 2 : return 0x5B;
L_mask4:
	MOVLW      91
	MOVWF      R0+0
	GOTO       L_end_mask
;7SegDis.c,8 :: 		case 3 : return 0x4F;
L_mask5:
	MOVLW      79
	MOVWF      R0+0
	GOTO       L_end_mask
;7SegDis.c,9 :: 		case 4 : return 0x66;
L_mask6:
	MOVLW      102
	MOVWF      R0+0
	GOTO       L_end_mask
;7SegDis.c,10 :: 		case 5 : return 0x6D;
L_mask7:
	MOVLW      109
	MOVWF      R0+0
	GOTO       L_end_mask
;7SegDis.c,11 :: 		case 6 : return 0x7D;
L_mask8:
	MOVLW      125
	MOVWF      R0+0
	GOTO       L_end_mask
;7SegDis.c,12 :: 		case 7 : return 0x07;
L_mask9:
	MOVLW      7
	MOVWF      R0+0
	GOTO       L_end_mask
;7SegDis.c,13 :: 		case 8 : return 0x7F;
L_mask10:
	MOVLW      127
	MOVWF      R0+0
	GOTO       L_end_mask
;7SegDis.c,14 :: 		case 9 : return 0x6F;
L_mask11:
	MOVLW      111
	MOVWF      R0+0
	GOTO       L_end_mask
;7SegDis.c,15 :: 		} //case end
L_mask0:
	MOVF       FARG_mask_num+0, 0
	XORLW      0
	BTFSC      STATUS+0, 2
	GOTO       L_mask2
	MOVF       FARG_mask_num+0, 0
	XORLW      1
	BTFSC      STATUS+0, 2
	GOTO       L_mask3
	MOVF       FARG_mask_num+0, 0
	XORLW      2
	BTFSC      STATUS+0, 2
	GOTO       L_mask4
	MOVF       FARG_mask_num+0, 0
	XORLW      3
	BTFSC      STATUS+0, 2
	GOTO       L_mask5
	MOVF       FARG_mask_num+0, 0
	XORLW      4
	BTFSC      STATUS+0, 2
	GOTO       L_mask6
	MOVF       FARG_mask_num+0, 0
	XORLW      5
	BTFSC      STATUS+0, 2
	GOTO       L_mask7
	MOVF       FARG_mask_num+0, 0
	XORLW      6
	BTFSC      STATUS+0, 2
	GOTO       L_mask8
	MOVF       FARG_mask_num+0, 0
	XORLW      7
	BTFSC      STATUS+0, 2
	GOTO       L_mask9
	MOVF       FARG_mask_num+0, 0
	XORLW      8
	BTFSC      STATUS+0, 2
	GOTO       L_mask10
	MOVF       FARG_mask_num+0, 0
	XORLW      9
	BTFSC      STATUS+0, 2
	GOTO       L_mask11
;7SegDis.c,16 :: 		}
L_end_mask:
	RETURN
; end of _mask

_interrupt:
	MOVWF      R15+0
	SWAPF      STATUS+0, 0
	CLRF       STATUS+0
	MOVWF      ___saveSTATUS+0
	MOVF       PCLATH+0, 0
	MOVWF      ___savePCLATH+0
	CLRF       PCLATH+0

;7SegDis.c,24 :: 		void interrupt() {
;7SegDis.c,25 :: 		PORTA = 0;                             // Turn off all 7seg displays
	CLRF       PORTA+0
;7SegDis.c,26 :: 		PORTD = portd_array[portd_index];      // bring appropriate value to PORTD
	MOVF       _portd_index+0, 0
	ADDLW      _portd_array+0
	MOVWF      FSR
	MOVF       INDF+0, 0
	MOVWF      PORTD+0
;7SegDis.c,27 :: 		PORTA = shifter;                       // turn on appropriate 7seg. display
	MOVF       _shifter+0, 0
	MOVWF      PORTA+0
;7SegDis.c,30 :: 		shifter <<= 1;
	MOVF       _shifter+0, 0
	MOVWF      R1+0
	RLF        R1+0, 1
	BCF        R1+0, 0
	MOVF       R1+0, 0
	MOVWF      _shifter+0
;7SegDis.c,31 :: 		if (shifter > 8u)
	MOVF       R1+0, 0
	SUBLW      8
	BTFSC      STATUS+0, 0
	GOTO       L_interrupt12
;7SegDis.c,32 :: 		shifter = 1;
	MOVLW      1
	MOVWF      _shifter+0
L_interrupt12:
;7SegDis.c,35 :: 		portd_index++ ;
	INCF       _portd_index+0, 1
;7SegDis.c,36 :: 		if (portd_index > 3u)
	MOVF       _portd_index+0, 0
	SUBLW      3
	BTFSC      STATUS+0, 0
	GOTO       L_interrupt13
;7SegDis.c,37 :: 		portd_index = 0;                     // turn on 1st, turn off 2nd 7seg.
	CLRF       _portd_index+0
L_interrupt13:
;7SegDis.c,39 :: 		TMR0   =   0;                          // reset TIMER0 value
	CLRF       TMR0+0
;7SegDis.c,40 :: 		INTCON = 0x20;                         // Clear T0IF
	MOVLW      32
	MOVWF      INTCON+0
;7SegDis.c,41 :: 		}
L_end_interrupt:
L__interrupt35:
	MOVF       ___savePCLATH+0, 0
	MOVWF      PCLATH+0
	SWAPF      ___saveSTATUS+0, 0
	MOVWF      STATUS+0
	SWAPF      R15+0, 1
	SWAPF      R15+0, 0
	RETFIE
; end of _interrupt

_main:

;7SegDis.c,43 :: 		void main() {
;7SegDis.c,44 :: 		ANSEL       =    0;                    // Set AN pins to Digital I/O
	CLRF       ANSEL+0
;7SegDis.c,45 :: 		ANSELH      =    0;
	CLRF       ANSELH+0
;7SegDis.c,46 :: 		C1ON_bit = 0;                          // Disable comparators
	BCF        C1ON_bit+0, 7
;7SegDis.c,47 :: 		C2ON_bit = 0;
	BCF        C2ON_bit+0, 7
;7SegDis.c,48 :: 		oldstate=0;
	BCF        _oldstate+0, BitPos(_oldstate+0)
;7SegDis.c,49 :: 		oldstate1=0;
	BCF        _oldstate1+0, BitPos(_oldstate1+0)
;7SegDis.c,50 :: 		oldstate2=0;
	BCF        _oldstate2+0, BitPos(_oldstate2+0)
;7SegDis.c,51 :: 		OPTION_REG  = 0x80;                    // Timer0 settings
	MOVLW      128
	MOVWF      OPTION_REG+0
;7SegDis.c,52 :: 		digit       =    0;
	CLRF       _digit+0
	CLRF       _digit+1
;7SegDis.c,53 :: 		portd_index =    0;
	CLRF       _portd_index+0
;7SegDis.c,54 :: 		shifter     =    1;
	MOVLW      1
	MOVWF      _shifter+0
;7SegDis.c,55 :: 		TMR0        =    0;
	CLRF       TMR0+0
;7SegDis.c,56 :: 		INTCON      = 0xA0;                    // Enable GIE, T0IE
	MOVLW      160
	MOVWF      INTCON+0
;7SegDis.c,57 :: 		PORTA       =    0;
	CLRF       PORTA+0
;7SegDis.c,58 :: 		TRISA       =    0;                    // Set PORTA as output
	CLRF       TRISA+0
;7SegDis.c,59 :: 		PORTD       =    0;
	CLRF       PORTD+0
;7SegDis.c,60 :: 		TRISD       =    0;                    // Set PORTD as output
	CLRF       TRISD+0
;7SegDis.c,61 :: 		TRISC=0XFF;
	MOVLW      255
	MOVWF      TRISC+0
;7SegDis.c,64 :: 		number          = 000;              // some initial value
	CLRF       _number+0
	CLRF       _number+1
;7SegDis.c,65 :: 		do {
L_main14:
;7SegDis.c,68 :: 		digit = (number / 100u) % 10u;         // extract hundreds digit
	MOVLW      100
	MOVWF      R4+0
	CLRF       R4+1
	MOVF       _number+0, 0
	MOVWF      R0+0
	MOVF       _number+1, 0
	MOVWF      R0+1
	CALL       _Div_16x16_U+0
	MOVLW      10
	MOVWF      R4+0
	CLRF       R4+1
	CALL       _Div_16x16_U+0
	MOVF       R8+0, 0
	MOVWF      R0+0
	MOVF       R8+1, 0
	MOVWF      R0+1
	MOVF       R0+0, 0
	MOVWF      _digit+0
	MOVF       R0+1, 0
	MOVWF      _digit+1
;7SegDis.c,69 :: 		portd_array[2] = mask(digit);        // and store it to PORTD array
	MOVF       R0+0, 0
	MOVWF      FARG_mask_num+0
	CALL       _mask+0
	MOVF       R0+0, 0
	MOVWF      _portd_array+2
;7SegDis.c,70 :: 		digit = (number / 10u) % 10u;        // extract tens digit
	MOVLW      10
	MOVWF      R4+0
	CLRF       R4+1
	MOVF       _number+0, 0
	MOVWF      R0+0
	MOVF       _number+1, 0
	MOVWF      R0+1
	CALL       _Div_16x16_U+0
	MOVLW      10
	MOVWF      R4+0
	CLRF       R4+1
	CALL       _Div_16x16_U+0
	MOVF       R8+0, 0
	MOVWF      R0+0
	MOVF       R8+1, 0
	MOVWF      R0+1
	MOVF       R0+0, 0
	MOVWF      _digit+0
	MOVF       R0+1, 0
	MOVWF      _digit+1
;7SegDis.c,71 :: 		portd_array[1] = mask(digit);        // and store it to PORTD array
	MOVF       R0+0, 0
	MOVWF      FARG_mask_num+0
	CALL       _mask+0
	MOVF       R0+0, 0
	MOVWF      _portd_array+1
;7SegDis.c,72 :: 		digit = number % 10u;                // extract ones digit
	MOVLW      10
	MOVWF      R4+0
	CLRF       R4+1
	MOVF       _number+0, 0
	MOVWF      R0+0
	MOVF       _number+1, 0
	MOVWF      R0+1
	CALL       _Div_16x16_U+0
	MOVF       R8+0, 0
	MOVWF      R0+0
	MOVF       R8+1, 0
	MOVWF      R0+1
	MOVF       R0+0, 0
	MOVWF      _digit+0
	MOVF       R0+1, 0
	MOVWF      _digit+1
;7SegDis.c,73 :: 		portd_array[0] = mask(digit);        // and store it to PORTD array
	MOVF       R0+0, 0
	MOVWF      FARG_mask_num+0
	CALL       _mask+0
	MOVF       R0+0, 0
	MOVWF      _portd_array+0
;7SegDis.c,75 :: 		Delay_ms(10);                      // one second delay
	MOVLW      26
	MOVWF      R12+0
	MOVLW      248
	MOVWF      R13+0
L_main17:
	DECFSZ     R13+0, 1
	GOTO       L_main17
	DECFSZ     R12+0, 1
	GOTO       L_main17
	NOP
;7SegDis.c,76 :: 		if (Button(&PORTc, 0, 1, 1)) oldstate = 1;
	MOVLW      PORTC+0
	MOVWF      FARG_Button_port+0
	CLRF       FARG_Button_pin+0
	MOVLW      1
	MOVWF      FARG_Button_time_ms+0
	MOVLW      1
	MOVWF      FARG_Button_active_state+0
	CALL       _Button+0
	MOVF       R0+0, 0
	BTFSC      STATUS+0, 2
	GOTO       L_main18
	BSF        _oldstate+0, BitPos(_oldstate+0)
L_main18:
;7SegDis.c,77 :: 		if (oldstate && Button(&PORTc, 0, 1, 0)) {
	BTFSS      _oldstate+0, BitPos(_oldstate+0)
	GOTO       L_main21
	MOVLW      PORTC+0
	MOVWF      FARG_Button_port+0
	CLRF       FARG_Button_pin+0
	MOVLW      1
	MOVWF      FARG_Button_time_ms+0
	CLRF       FARG_Button_active_state+0
	CALL       _Button+0
	MOVF       R0+0, 0
	BTFSC      STATUS+0, 2
	GOTO       L_main21
L__main32:
;7SegDis.c,78 :: 		number +=100;
	MOVLW      100
	ADDWF      _number+0, 1
	BTFSC      STATUS+0, 0
	INCF       _number+1, 1
;7SegDis.c,79 :: 		oldstate = 0;
	BCF        _oldstate+0, BitPos(_oldstate+0)
;7SegDis.c,80 :: 		}
L_main21:
;7SegDis.c,82 :: 		if (Button(&PORTc, 1, 1, 1)) oldstate1 = 1;
	MOVLW      PORTC+0
	MOVWF      FARG_Button_port+0
	MOVLW      1
	MOVWF      FARG_Button_pin+0
	MOVLW      1
	MOVWF      FARG_Button_time_ms+0
	MOVLW      1
	MOVWF      FARG_Button_active_state+0
	CALL       _Button+0
	MOVF       R0+0, 0
	BTFSC      STATUS+0, 2
	GOTO       L_main22
	BSF        _oldstate1+0, BitPos(_oldstate1+0)
L_main22:
;7SegDis.c,83 :: 		if (oldstate1 && Button(&PORTc, 1, 1, 0)) {
	BTFSS      _oldstate1+0, BitPos(_oldstate1+0)
	GOTO       L_main25
	MOVLW      PORTC+0
	MOVWF      FARG_Button_port+0
	MOVLW      1
	MOVWF      FARG_Button_pin+0
	MOVLW      1
	MOVWF      FARG_Button_time_ms+0
	CLRF       FARG_Button_active_state+0
	CALL       _Button+0
	MOVF       R0+0, 0
	BTFSC      STATUS+0, 2
	GOTO       L_main25
L__main31:
;7SegDis.c,84 :: 		number +=10;
	MOVLW      10
	ADDWF      _number+0, 1
	BTFSC      STATUS+0, 0
	INCF       _number+1, 1
;7SegDis.c,85 :: 		oldstate1 = 0;
	BCF        _oldstate1+0, BitPos(_oldstate1+0)
;7SegDis.c,86 :: 		}
L_main25:
;7SegDis.c,87 :: 		if (Button(&PORTc, 2, 1, 1)) oldstate2 = 1;
	MOVLW      PORTC+0
	MOVWF      FARG_Button_port+0
	MOVLW      2
	MOVWF      FARG_Button_pin+0
	MOVLW      1
	MOVWF      FARG_Button_time_ms+0
	MOVLW      1
	MOVWF      FARG_Button_active_state+0
	CALL       _Button+0
	MOVF       R0+0, 0
	BTFSC      STATUS+0, 2
	GOTO       L_main26
	BSF        _oldstate2+0, BitPos(_oldstate2+0)
L_main26:
;7SegDis.c,88 :: 		if (oldstate2 && Button(&PORTc, 2, 1, 0)) {
	BTFSS      _oldstate2+0, BitPos(_oldstate2+0)
	GOTO       L_main29
	MOVLW      PORTC+0
	MOVWF      FARG_Button_port+0
	MOVLW      2
	MOVWF      FARG_Button_pin+0
	MOVLW      1
	MOVWF      FARG_Button_time_ms+0
	CLRF       FARG_Button_active_state+0
	CALL       _Button+0
	MOVF       R0+0, 0
	BTFSC      STATUS+0, 2
	GOTO       L_main29
L__main30:
;7SegDis.c,89 :: 		number +=1;
	INCF       _number+0, 1
	BTFSC      STATUS+0, 2
	INCF       _number+1, 1
;7SegDis.c,90 :: 		oldstate2 = 0;
	BCF        _oldstate2+0, BitPos(_oldstate2+0)
;7SegDis.c,91 :: 		}
L_main29:
;7SegDis.c,97 :: 		}while(1) ;
	GOTO       L_main14
;7SegDis.c,98 :: 		}
L_end_main:
	GOTO       $+0
; end of _main
